#         Script : SKooL v1.02 by David Proper (Dr. Nibble [DrN])
#                  Copyright 2002-2003 Radical Computer Systems
#                             All Rights Reserved
#
#       Testing
#      Platforms : Linux 2.4.18   TCL v8.3
#                  Eggdrop v1.6.2
#                  Eggdrop v1.6.6
#            And : SunOS 5.8      TCL v8.3
#                  Eggdrop v1.5.4
#
#    Description : SKooL lets your bot run those lessons you find on
#                  most networks. It trys to make running them easy on
#                  the OPs. 
#
#        History : 09/04/2002 - First Release
#                  09/09/2002 - v1.01 
#                              o Fixed skool(tag) error
#                              o Added o|o flags to channel command
#                              o Readded MSG/DCC commands. Somewhere along
#                                the line I must of overwrote with an 
#                                older version. heh.
#                              o Added in list command
#                              o Adds .skl on load file name if not there
#                                 Either one works:
#                                  !skool load mirc.skl 
#                                  !skool load mirc 
#                              o Can now send output of channel/msg 
#                                commands in privmsg or notice.
#                                (Requested by reed@Undernet)
#                              o Added F(reeze) dialog command
#                                (Requested by reed@Undernet)
#                              o Marker borders are definable
#                                (Cause reed's anal. lol)
#                  07/13/2003 - v1.02
#                              o Fixed repeating header in DCC
#                                (Reported by Reed@UnderNet)
#                              o Fixed error if lesson is stopped while 
#                                it's paused/frozen.
#                                (Reported by Nirvana00@UnderNet)
#                              o Fixed can't read "nick": no such variable
#                                (Reported by Nirvana00@UnderNet)
#
#      Donations : https://www.paypal.com/xclick/business=pproper%40satx.rr.com
# (If you don't have PayPal and want to donate, EMail me for an address.
#  Will take money or hardware/computer donations)
#  Significant (or even non-significant donations) can be published on a
#  web site if you so choose.
#
#   Future Plans : Fix Bugs. :)
#   <reed> for questions and stuff
#             like a take-a-number for questions
#             /msg IRCd-Univ skool question <question here>
#   <reed> make this class script work with netlink
#          (Quick Fix: Run skool and netlink from 2 diff bots)
#
# Author Contact :     Email - DProper@chaotix.net
#                   Homepage - http://www.chaotix.net/~dproper
#                        IRC - Primary Nick: DrN
#                     UseNet - alt.irc.bots.eggdrop
# Support Channels: #RCS @UnderNet.Org
#                   #RCS @DALnet
#                   #RCS @EFnet
#                   #RCS @Choatix Addiction
#            Other channels - Check contact page for current list
#
#                Current contact information can be located at:
#                 http://rcs.chaotix.net/contact.html
#
# New TCL releases are sent to the following sites as soon as they're released:
#
# FTP Site                   | Directory                     
# ---------------------------+-------------------------------
# ftp.chaotix.net            | /pub/RCS
# ftp.eggheads.org           | Various
#
#   Radical Computer Systems - http://www.chaotix.net/rcs/
# To subscribe to the RCS mailing list:
# http://www.chaotix.net/mailman/listinfo/rcs-list
#
#  Feel free to Email me any suggestions/bug reports/etc.
# 
# You are free to use this TCL/script as long as:
#  1) You don't remove or change author credit
#  2) You don't release it in modified form. (Only the original)
# 
# If you have a "too cool" modification, send it to me and it'll be
# included in the official release. (With your credit)
#
# Commands Added:
#  Where     F CMD          F CMD            F CMD           F CMD
#  -------   - ----------   - ------------   - -----------   - ----------
#  Public:   o !skool
#     MSG:   o skool
#     DCC:   o skool
#
# Public Matching: N/A
#

# SKOOL Commands:
#  LOAD filename      - This will load a lesson into the script
#  RUN [marker]       - This will start the loaded lesson. Start at marker 
#                       or beginning if no marker is given.
#  STOP               - This will abort a currently running lesson
#  PAUSE              - This will pause a running lesson
#  UNPAUSE            - This will unpause a running lesson
#  TOPIC              - This will display the topic of the currently 
#                       loaded lesson
#  LIST               - This will list all class files


# Commands for lesson file:
# !tag
# This sets a marker so you can continue a lesson in case of interruption
#  EX: !E12
#  This will display (E12) at the end of the next text line and allow you
#  to continue with:    !skool run E12
# F
# Will auto-pause (freeze) script. skool unpause is required by an OP.
# P#
#  Pause for # seconds               EX: P15
# Mdata
#  Change channel modes to data      EX: M+m
# Wmsg
#  Send a message to all OPs         EX: WLesson paused 15 seconds.
# Ttopic
#  Change channel topic              EX: TToday's lesson: %topic%
# ;
#  Lines starting with a ; are ignored and not loaded.
# =topic
#  Set the lesson topic              EX: =MIRC Scripting 101
# Any text starting with a space is sent to the channel.

# Variables usable in lesson output:
#  %channel%            - Channel which lesson is taking place on
#  %nick%               - Nick of the person who started the lesson
#  %topic%              - Lesson topic as defined by the = command

if {[info exists skool_lesson]} {unset skool_lesson}


# Change the ! to whatever public trigger you want.
# If left as ! then the command is !skool
if {![info exists cmdchar_]} {set cmdchar_ "!"}

# Directory to find lesson files in (Put all the *.skl here)
set skool(data) "/home/eggdrop/scripts/rcs/school/"

# Default text output delay in seconds
set skool(delay) 3

# [0/1] Set this to 1 to send output of channel/message commands in notice
# 0 will send to channel.
# 1 will send to user.
set skool(public) 1


# Left marker border
set skool(left) "\["
# Right marker border
set skool(right) "\]"


# Variables used internally by script. Don't be an idiot and fuck with them.
set skool(ver) "v1.02.02"
set skool(run) 0
set skool(load) 0
set skool(timer) ""
set skool_lesson(max) 0
set skool_lesson(cur) 0
set skool(tag) ""

proc cmdchar { } {global cmdchar_; return $cmdchar_}

bind dcc o skool dcc_skool
proc dcc_skool {handle idx rest} {
 set chan [string tolower [lindex [console $idx] 0]]
 pub_skool $idx * $handle $chan $rest
}

bind msg o skool msg_skool
proc msg_skool {nick uhost hand rest} {
global botnick
set chan [lindex $rest 0]
set rest [lrange $rest 1 end]
if {([string index [lindex $chan 0] 0] != "#")} {
   skool_out $nick $nick "Calling Syntax is: /msg $botnick skool #channel cmd"
   return 0}
if {[validchan $chan] == 0} {skool_out $nick $nick "$chan is an invalid channel"                                   return 0}

pub_skool $nick * $hand $chan $rest
}

bind pub o|o [cmdchar]skool pub_skool
proc pub_skool {nick uhost hand chan rest} {
global skool
 set cmd [string toupper [lindex $rest 0]]
 set rest [lrange $rest 1 end]
 switch $cmd {
  "" {skool_out $nick $chan "Available Commands: LOAD RUN STOP PAUSE UNPAUSE TOPIC LIST"}
  "LOAD" {skool_load $chan $nick $rest}
  "RUN" {skool_run $chan $nick $rest}
  "STOP" {skool_stop $chan $nick $rest}
  "PAUSE" {skool_pause $chan $nick $rest}
  "UNPAUSE" {skool_unpause $chan $nick $rest}
  "TOPIC" {skool_topic $chan $nick $rest}
  "LIST" {skool_list $chan $nick $rest}
             }

 return 0
}

proc skool_list {chan nick rest} {
global skool
 exec rm -f "${skool(data)}.dir"
 if {[catch {exec /bin/ls -1 ${skool(data)} > ${skool(data)}.dir}]} {
     putlog "ERROR: ls not found on system."
     return 1
    }
 set cnt 0
 set in [open $skool(data).dir]
 skool_out $nick $chan "## Class      Description"
 skool_out $nick $chan "-- ---------- -------------------------------"
 while {![eof $in]} {
                gets $in line
     if {[string tolower [string range $line [expr [string length $line] - 4] [string length $line]]] == ".skl"} {
                incr cnt 1
 set ftopic ""
 set fin [open $skool(data)$line r]

# I miss the old ANSi graphics from the BBS. ASCII just isn't as cool. haha.
# I miss my old BBS too. 

 while {![eof $fin]} {
 set fline [gets $fin]
 set cmd [string index $fline 0]
 if {$cmd == "="} {
                   set ftopic [string range $fline 1 end]
                  }
                    }
 close $fin
 if {$ftopic == ""} {set ftopic "No lesson topic set"}
 set line [string range $line 0 [expr [string length $line] - 5]]
                skool_out $nick $chan "\026[format "%2s" $cnt]\026 [format "%-10s" $line] $ftopic"
                  }
                    }
 close $in
 skool_out $nick $chan "Listed $cnt class file[thes $cnt]."
}

proc thes {num} {
if {$num == 1} {return ""} else {return "s"}
}


proc skool_topic {chan nick rest} {
global skool
 if {$skool(load) == 0} {skool_out $nick $chan "There is currently no lesson loaded."; return 0}
 skool_out $nick $chan "Currently loaded lesson is: $skool(topic)"
}

proc skool_unpause {chan nick rest} {
global skool
 if {$skool(run) == 0} {skool_out $nick $chan "There is no lesson running."; return 0}
 if {$skool(pause) == 0} {skool_out $nick $chan "lesson isn't currently paused."; return 0}
# skool_out $nick $chan "Resuming Lesson"
# if {[info exists skool(timer)]} {killutimer $skool(timer)}
 skool_out $nick $skool(chan) "Resuming Lesson"
 set skool(timer) [utimer $skool(delay) skool_teach]
 set skool(pause) 0
}

proc skool_pause {chan nick rest} {
global skool
 if {$skool(run) == 0} {skool_out $nick $chan "There is no lesson running."; return 0}
 if {$skool(pause) == 1} {skool_out $nick $chan "Lesson is all ready paused."; return 0}
# skool_out $nick $chan "Pausing Lesson"
 if {[info exists skool(timer)]} {killutimer $skool(timer)}
 set skool(timer) ""
 set skool(pause) 1
 skool_out $nick $skool(chan) "Lesson Paused by $nick"
}

proc skool_stop {chan nick rest} {
global skool skool_lesson
 if {$skool(run) == 0} {skool_out $nick $chan "There is no lesson running."; return 0}
# skool_out $nick $chan "Aborting Lesson"
 if {$skool(pause) == 0} {
  if {[info exists skool(timer)]} {killutimer $skool(timer)}
                         }
 set skool(timer) ""
 set skool(run) 0
 set skool(cur) [expr $skool_lesson(max) + 1]
 skool_out $nick $skool(chan) "Lesson Aborted by $nick"
}

proc skool_run {chan nick rest} {
global skool skool_lesson
 if {$skool(run) == 1} {skool_out $nick $chan "There is currently a lesson running."; return 0}
 if {$skool(load) == 0} {skool_out $nick $chan "There is currently no lesson loaded. Can't teach if there's nothing to teach."; return 0}

 set skool_lesson(cur) 0
 
if {$rest != ""} {
 set sloop 0
 set sfound 0
 set rest [string toupper $rest]
 while {$sloop < $skool_lesson(max)} {
  incr sloop
  set line $skool_lesson($sloop)
  set cmd [string index $line 0]
  set line [string toupper [string range $line 1 end]]
  if {($cmd == "!") && ($rest == $line)} {
                                          set skool_lesson(cur) [expr $sloop - 1]
                                          set sfound 1
                                          skool_out $nick $chan "Found Marker $rest - Continuing"
                                         }
                                     }
 if {$sfound == 0} {skool_out $nick $chan "Sorry, can't find $rest marker"
                    return 0}
                 }
 set skool(chan) $chan
 set skool(started) $nick
 set skool(run) 1
 set skool(pause) 0
 set skool(timer) [utimer $skool(delay) skool_teach]
}

proc skool_teach {} {
global skool skool_lesson
 set chan $skool(chan)
 set delay $skool(delay)

if {$skool_lesson(cur) >= $skool_lesson(max)} {
 set skool(timer) ""
 set skool(run) 0
# Do NOT remove this information block. If you want it gone, then pay for
# using the script. If you don't want this info and you don't want to pay
# for it, then write your own damn script. And don't steal my code.
 putserv "PRIVMSG $skool(chan) :SKooL $skool(ver) by David Proper (DrN)"
 putserv "PRIVMSG $skool(chan) :Copyright 2003 Radical Computer Systems - All Rights Reserved"
 putserv "PRIVMSG $skool(chan) :http://rcs.chaotix.net/"
 return 0
                                             }
 incr skool_lesson(cur) 1
 set line $skool_lesson($skool_lesson(cur))
 set cmd [string index $line 0]
 set line [string range $line 1 end]

 regsub -all {%channel%} $line $chan line
 regsub -all {%nick%} $line $skool(started) line
 regsub -all {%topic%} $line $skool(topic) line

 switch $cmd {
  "F" {
       set skool(timer) ""
       set skool(pause) 1
       skool_out $skool(started) $skool(chan) "Lesson Paused"
      }
  "W" {wallops $chan $line}
  "P" {set delay $line}
  "M" {putserv "MODE $chan $line"}
  "!" {set skool(tag) $line}
  " " {if {$skool(tag) == ""} {
#                               skool_out $chan $chan $line
                               putserv "PRIVMSG $chan :$line"
                             } else {
#                              skool_out $chan $chan "$line \($skool(tag)\)"
                              putserv "PRIVMSG $chan :$line ${skool(left)}$skool(tag)${skool(right)}"
                                    }
       set skool(tag) ""}
  "T" {putserv "TOPIC $chan :$line"}
             }
 set skool(timer) [utimer $delay skool_teach]

}

proc skool_load {chan nick rest} {
global skool skool_lesson
 set df [lindex $rest 0]
 if {$df == ""} {skool_out $nick $chan "Calling Syntax: [cmdchar]skool load lessonfile"; return 0}
 if {$skool(run) == 1} {skool_out $chan $nick "There is currently a lesson running. Loading new data would fuck shit up."; return 0}

 if {[string tolower [string range $df [expr [string length $df] - 4] [string length $df]]] != ".skl"} {set df "${df}.skl"}

 if {![file exists $skool(data)$df]} {
  skool_out $nick $chan "I can't find $skool(data)$df"; return 0
                        }
if {[info exists skool_lesson]} {unset skool_lesson}
set skool_lesson(max) 0
set skool_lesson(cur) 0
set skool(topic) ""

 set in [open $skool(data)$df r]
 while {![eof $in]} {
 set line [gets $in]
 set cmd [string index $line 0]
 set saveit 1
 if {$line == ""} {set saveit 0}
 if {$cmd == ";"} {set saveit 0}
 if {$cmd == "="} {
                   set saveit 0
                   set skool(topic) [string range $line 1 end]
                  }
 if {$saveit == 1} {
  incr skool_lesson(max) 1
  set skool_lesson($skool_lesson(max)) "$line"
                   }
                    }
 close $in
skool_out $nick $chan "Loaded: $skool(topic)   $skool_lesson(max) lines read."
set skool(load) 1
}

# isnumber taken from alltools.tcl
proc isnum {string} {
  if {([string compare $string ""]) && (![regexp \[^0-9\] $string])} then {return 1}
  return 0
}

proc wallops {chan msg} {
    foreach user1 [chanlist $chan] {
     set hand [nick2hand $user1 $chan]
     if {![onchansplit $user1 $chan] && ([isop $user1 $chan] || ([matchattr $hand o]))} {
      set oplist $user1
      putserv "NOTICE $oplist :(\002OPmsg\002/$chan) $msg"
      unset oplist
                                                             }
                                   }
}


proc skool_out {nick channel txt} {
global skool
 regsub -all {!PD!} $txt \. txt
 regsub -all {!CO!} $txt \: txt
 regsub -all {!SQ!} $txt \' txt
 regsub -all {!QL!} $txt \; txt
 regsub -all {!QT!} $txt \" txt
 regsub -all {!LT!} $txt \< txt
 regsub -all {!GT!} $txt \> txt
 regsub -all {!LP!} $txt \( txt
 regsub -all {!RP!} $txt \) txt
 regsub -all {!LB!} $txt \{ txt
 regsub -all {!RB!} $txt \} txt
 regsub -all {!LF!} $txt \[ txt
 regsub -all {!RF!} $txt \] txt
 regsub -all {!SL!} $txt \\ txt
 set otype "PRIVMSG"
 set oto $channel
 if {$skool(public)==1} {set otype "NOTICE"; set oto $nick}
 if {[isnum $nick]} {putidx $nick "$txt"
                    } else {
                            puthelp "$otype $oto :$txt"
                           }
# if {$dirc == "1"} { putserv "PRIVMSG $channel :$txt" }
# if {$dirc == "2"} { putserv "PRIVMSG $nick :$txt" }
# if {$dirc == "3"} { putserv "NOTICE $nick :$txt" }
# if {$dirc == "4"} { putdcc $nick "$txt" }
}

putlog "SKooL $skool(ver) by David Proper (DrN) -: LoadeD :-"
return "SKooL $skool(ver) by David Proper (DrN) -: LoadeD :-"

